
// Efinity Top-level template
// Version: 2020.1.140
// Date: 2020-07-24 21:04

// Copyright (C) 2017 - 2020 Efinix Inc. All rights reserved.

// This file may be used as a starting point for Efinity synthesis top-level target.
// The port list here matches what is expected by Efinity constraint files generated
// by the Efinity Interface Designer.

// To use this:
//     #1)  Save this file with a different name to a different directory, where source files are kept.
//              Example: you may wish to save as /home/alfredw_local/github/xyloni/design/helloworld/efinity/xyloni.v
//     #2)  Add the newly saved file into Efinity project as design file
//     #3)  Edit the top level entity in Efinity project to:  xyloni
//     #4)  Insert design content.

`include "dig.v"   

module xyloni
(
  input BTN1,
  input BTN2_J2_7,
  input [14:0] GPIO_J1_IN,
  input [13:0] GPIO_J2_IN,
  input [8:0] GPIO_J3_IN,
  input RXD,
  input SD_DI,
  input SPI_MISO,
  //input i_sysclk,
  //input i_pll_locked,
  
  input clk_12p5,
  input i_sysclk, //clk_25,
  
  output [2:0] GPIO_J1_OUT,
  output [2:0] GPIO_J1_OE,
  output [13:0] GPIO_J2_OUT,
  output [13:0] GPIO_J2_OE,
  /*
  output [14:0] GPIO_J1_OUT,
  output [14:0] GPIO_J1_OE,

  output [8:0] GPIO_J3_OUT,
  output [8:0] GPIO_J3_OE,
  */
  output LED1,
  output LED2,
  output LED3_J2_6,
  output LED4_J2_5
  /*
  output SD_CS,
  output SD_DO,
  output SD_SCLK,
  output SPI_MOSI,
  output SPI_SCLK,
  output SPI_SS,
  output TXD
  */
);


  
  `include "features.v"



//
// reg and wire declarations
//
reg                 nres;
wire         [7:0]  cfg;
wire        [31:0]  pin_out, pin_dir;

wire                clkfb, clock_160, clk;
reg         [23:0]  reset_cnt;
reg                 reset_to;
wire                clk_pll;
wire                clk_cog;

wire         [31:0] pin_in;// = io;
`ifdef USE_PORTB
wire         [31:0] pin_inb;// = iob;  //PortB
wire        [31:0]  pin_outb, pin_dirb;  //PortB
`endif

wire [8:0] px0;
wire [7:0] cogleds;
//assign led = px0 [7:0];  //For testing, was looking at program counter on cog#0
//assign led = cogleds;
assign LED1 = cogleds[0];
assign LED2 = cogleds[1];
assign LED3_J2_6 = inp_resn;
assign LED4_J2_5 = GPIO_J1_IN[1];

//PropPlug RES on J1-pin4 = GPIOR_20 = = GPIO_J1[0]
//PropPlug Tx on J1-pin5 = GPIOR_21 = = GPIO_J1[1]
//PropPlug Rx on J1-pin6 = GPIOR_22 = = GPIO_J1[2]


assign pin_in = {GPIO_J1_IN[1], 1'b0, 14'b0, 2'b0, GPIO_J2_IN[13:0]};  //RJA for Prop Plug
wire inp_resn = GPIO_J1_IN[0];


wire [31:0] io;

assign GPIO_J1_OUT[1:0] = 0;  //Not using these for output
assign GPIO_J1_OE[1:0] = 0; 


assign GPIO_J1_OUT[2] = pin_out [30];  //Prop Plug - Output to FTDI
assign GPIO_J1_OE[2] = pin_dir [30]; 

assign GPIO_J2_OUT[13:0] = pin_out [13:0]; 
assign GPIO_J2_OE[13:0] = pin_dir [13:0]; 




`ifdef USE_PORTB
wire [31:0] iob;
assign gp[27:16] = iob[11:0];  
`ifdef USE_PROPPLUG
assign gn[27-3:16] = iob[23-3:12]; //RJA -3 to make room for prop Plug
`else
assign gn[27:16] = iob[23:12]; 
`endif //USE_PROPPLUG
`endif //USE_PORTB

//
// Clock generation
//

wire [4:0] _dummy_clk;

assign clk=clock_160;//RJA
wire clk_rcfast;
//PLL1 PLL1_inst(clk_25mhz, clock_160, clock_rcfast, clock_80);

//    
// Clock control
//
/*
tim clkgen( .clk        (clock_160),
	        .clk_half    (clock_80),
			.clk_rcfast (clock_rcfast),
            .res        (~inp_resn),
            .cfg        (cfg[6:0]),
            .clk_pll    (clk_pll),
            .clk_cog    (clk_cog)
          );
*/
assign clk_pll=i_sysclk;//clk_25;
assign clk_cog = clk_12p5;
//
// Propeller 1 core module
//

dig core (  .nres       (nres),
            .cfg        (cfg),
            .clk_cog    (clk_cog),
            .clk_pll    (clk_pll),
            .pin_in     (pin_in),
            .pin_out    (pin_out),
            .pin_dir    (pin_dir),
`ifdef USE_PORTB			
			.pin_inb     (pin_inb),  //PortB
            .pin_outb    (pin_outb),  //PortB
            .pin_dirb    (pin_dirb),  //PortB
`endif			
			.px0(px0), //RJA bringing out program counter for troubleshooting
            .cog_led    (cogleds) );

always @ (posedge clk_cog)
    nres <= inp_resn & !cfg[7];

//
// Bidir I/O buffers
//
/*
genvar i;
generate
    for (i=0; i<32; i=i+1)
    begin : iogen
		if (i==30)
		begin	
		  assign io[i] = pin_dir[i] ? pin_out[i] : 1'bZ;
		  assign ftdi_rxd = pin_dir[i] ? pin_out[i] : 1'bZ;
		end
		else
          assign io[i] = pin_dir[i] ? pin_out[i] : 1'bZ;
`ifdef USE_PORTB		  
		assign iob[i] = pin_dirb[i] ? pin_outb[i] : 1'bZ;  //PortB
`endif		
    end
endgenerate
*/
endmodule
